#include "StdAfx.h"
#include "Comm.h"
#include "GGame.h"
#include "GSprites.h"

/*
GSprites 
*/
GSprites::GSprites()
{
}

/*
GSprites Ҹ
*/
GSprites::~GSprites()
{
	ReleaseTexture();
}


/*
GSprites::LoadTexture(DataInMem* file)

file ؽĸ о m_vptxt Ѵ.
*/
GRET GSprites::LoadTexture(DataInMem* file)
{
	if(!GGame::GetInstance()->GetDevice())return GRET_ERROR_NODEVICE;
	LPDIRECT3DTEXTURE9 ptxt;
	if(FAILED( D3DXCreateTextureFromFileInMemoryEx(GGame::GetInstance()->GetDevice(), 
		file->getsrc(), file->getsize(), 0, 0, 0, 0, D3DFMT_UNKNOWN, D3DPOOL_MANAGED,
		D3DX_DEFAULT, D3DX_DEFAULT, 0, NULL, NULL, &ptxt)) )
	{
		return GRET_ERROR_FAIL;
	}
	m_vptxt.push_back(ptxt);
	return GRET_OK;
}

/*
GSprites::ReleaseTexture()

  ؽĸ Ѵ.
*/
GRET GSprites::ReleaseTexture()
{
	for(size_t i=0;i<m_vptxt.size();i++)
	{
		SAFE_RELEASE(m_vptxt.back());
		m_vptxt.pop_back();
	}
	return GRET_OK;
}

/*
GSprites::AddSprites(DWORD itxt, int left, int top, int right, int bottom)

Ʈ ͸ m_vspr Ѵ.
*/
GRET GSprites::AddSprites(DWORD itxt, int left, int top, int right, int bottom)
{
	GSpriteDat d;
	d.itxt=itxt;
	d.rect.left=left;
	d.rect.top=top;
	d.rect.right=right;
	d.rect.bottom=bottom;
	m_vspr.push_back(d);
	return GRET_OK;
}

/*
GSprites::DrawSprite(UINT index, int x, int y, D3DCOLOR color)

indexȣ Ʈ ȭ  (x,y) color ׸.
*/
GRET GSprites::DrawSprite(UINT index, int x, int y, D3DCOLOR color) const
{
	if(m_vspr.size()<=index)return GRET_ERROR_PARAM;
	D3DXMATRIX mat;
	GGame::GetInstance()->GetSprite()->SetTransform(D3DXMatrixIdentity(&mat));
	if(FAILED( GGame::GetInstance()->GetSprite()
		->Draw(m_vptxt[m_vspr[index].itxt], 
		&m_vspr[index].rect, NULL, 
		&D3DXVECTOR3((float)x, (float)y, 0), color) ))
	{
		return GRET_ERROR_FAIL;
	}
	return GRET_OK;
}


